/*
* Copyright 2022-2023 ETSI TeraFlowSDN - TFS OSG (https://tfs.etsi.org/)
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

package eu.teraflow.policy.context;

import eu.teraflow.policy.context.model.Device;
import eu.teraflow.policy.context.model.Empty;
import eu.teraflow.policy.context.model.Service;
import eu.teraflow.policy.context.model.ServiceId;
import eu.teraflow.policy.model.PolicyRule;
import io.smallrye.mutiny.Uni;
import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;

@ApplicationScoped
public class ContextServiceImpl implements ContextService {

    private final ContextGateway contextGateway;

    @Inject
    public ContextServiceImpl(ContextGateway contextGateway) {
        this.contextGateway = contextGateway;
    }

    @Override
    public Uni<Service> getService(ServiceId serviceId) {
        return contextGateway.getService(serviceId);
    }

    @Override
    public Uni<ServiceId> setService(Service service) {
        return contextGateway.setService(service);
    }

    @Override
    public Uni<Device> getDevice(String deviceId) {
        return contextGateway.getDevice(deviceId);
    }

    @Override
    public Uni<PolicyRule> getPolicyRule(String policyRuleId) {
        return contextGateway.getPolicyRule(policyRuleId);
    }

    @Override
    public Uni<String> setPolicyRule(PolicyRule policyRule) {
        return contextGateway.setPolicyRule(policyRule);
    }

    @Override
    public Uni<Empty> removePolicyRule(String policyRuleId) {
        return contextGateway.removePolicyRule(policyRuleId);
    }
}
